package nl.pim16aap2.armoredElytra.nbtEditor.ArmoredElytraBuilder;

import nl.pim16aap2.armoredElytra.util.ArmorTier;
import org.bukkit.inventory.ItemStack;

/**
 * An interface describing the first step of building an armored elytra
 */
public interface ItemCreator {

    /**
     * Use an elytra as base item to create the new armored elytra from.
     *
     * @param elytra <p>An item-stack that represents an elytra. It does not matter whether the elytra is armored or not.</p>
     * @return <p>The next step of the builder process.</p>
     */
    ItemCombinator ofElytra(ItemStack elytra);

    /**
     * Creates a fresh new armored elytra of a specific tier.
     *
     * @param armorTier <p>The tier of the new armored elytra.</p>
     * @return <p>The next step of the builder process.</p>
     */
    ItemMetadataSetter newItem(ArmorTier armorTier);

}
